/*
 * Copyright (c) 2015 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __GALLERY_NATIVE_H__
#define __GALLERY_NATIVE_H__

#include <app.h>
#include <Elementary.h>
#include <system_settings.h>
#include <efl_extension.h>
#include <dlog.h>
#include <glib.h>
#include <json-glib/json-glib.h>
#include <eina_list.h>
#include <sap.h>

#define TAG "GalleryConsumer"

#if !defined(PACKAGE)
#define PACKAGE "org.tizen.gallerynative"
#endif

#define THUMBNAIL_LIST_REQ "gallery-thumbnail-req"
#define THUMBNAIL_LIST_RSP "gallery-thumbnail-rsp"
#define DOWNSCALE_IMG_REQ "gallery-image-req"
#define DOWNSCALE_IMG_RSP "gallery-image-rsp"
#define MSG_ID "msgId"
#define OFFSET "offset"
#define IMAGE_ID "id"
#define WIDTH "width"
#define HEIGHT "height"
#define IMAGE_NAME "name"
#define IMAGE "image"
#define GALLERY_ASPID "/sample/gallery"
#define GALLERY_CHANNELID 104

typedef struct image {
	char *msgId;
	int id;
	const char *data;
	size_t size;
	const char *name;
	const char *width;
	const char *height;
} image;


void     parse_list_res(JsonObject *jResponseData);
void     initialize_sap(void);
gboolean find_peers();
void     display_thumbnail_list(GList *);
gboolean request_img(int x);
void     request_list_msg(int);
void     display_image(void *img, size_t size, int width, int height);

#endif /* __GALLERY_NATIVE_H__ */

